import { DirectionEncoderPort } from '../core/application/ports/direction-encoder.port';
import { Injectable } from '@nestjs/common';
import { Point } from '../core/domain/route.types';

@Injectable()
export class PostgresDirectionEncoder implements DirectionEncoderPort {
  encode = (coordinates: Point[]): string =>
    [
      "'LINESTRING(",
      coordinates.map((point) => [point.lon, point.lat].join(' ')).join(),
      ")'",
    ].join('');
  decode = (direction: string): Point[] =>
    direction
      .split('(')[1]
      .split(')')[0]
      .split(',')
      .map((coordinates) => coordinates.split(' '))
      .map((point) => ({
        lon: parseFloat(point[0]),
        lat: parseFloat(point[1]),
      }));
}
